/*
 * Copyright (c) 2006
 *
 * written by Simon Barrick
 * simon@fourthwall.ndo.co.uk
 *
 * Wrap SOP
 */

#ifndef __SOP_RBFmorpher_h__
#define __SOP_RBFmorpher_h__

#include <SOP/SOP_Node.h>

class SOP_RBFmorpher : public SOP_Node
{
public:
    static PRM_Template    myTemplateList[];
    static OP_Node    *myConstructor(OP_Network*, const char *,
                  OP_Operator *);


protected:
       SOP_RBFmorpher(OP_Network *net, const char *name, OP_Operator *op);
    virtual ~SOP_RBFmorpher();

    virtual unsigned      disableParms();
    virtual const char          *inputLabel(unsigned int) const;

    // Method to cook geometry for the SOP
    virtual OP_ERROR       cookMySop(OP_Context &context);

    // This method is used to generate geometry for a "guide".
    //virtual OP_ERROR             cookMyGuide1(OP_Context &context);


private:
    fpreal64 rbfU(float r);

    int  KERNEL()               { return evalInt("kernel", 0, 0); }


};

#endif
